function seq = step( s, seq1, seq2 )
% function seq = step( s, seq1, seq2 )
%
% Given an integer s and two sequences (stairways) seq1, seq2, 
% return the sequences resulting from one application of the deterministic
% rule D(s) on the sequences seq1 and seq2.
%
% A sequence is encoded as a vector of positive integers.
% 
% Examples:
%   step( 3, [2 1 1], [3 3] )  yields [2 2 1 1 1]
%   step( 3, [3], [3] )        yields [2 2]
%   step( 3, [1], [1] )        yields []
%

big = max([seq1 seq2]);   % just a big number

seq1 = -sort(-seq1); % sort in a non-increasing order
seq2 = -sort(-seq2);

seq1(1) = seq1(1) + big; % add a big number to the largest element of seq1,seq2
seq2(1) = seq2(1) + big; % to make sure they are the biggest in the union

seq = [seq1 seq2]; % the union

seq = -sort(-seq); % sort in a non-increasing order

seq = seq - ((1:length(seq)) <= s); % decrement 1 from the s largest

seq([1 2]) = seq([1 2]) - big; % fix the +big modification

seq = -sort(-seq); % sort in a non-increasing order

seq = seq(find(seq>0)); % delete zeroes


